# coding: utf-8

"""
    avis

    VUE Autonomous Visual Inspection System (AVIS)

    The version of the OpenAPI document: 0.2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
import re  # noqa: F401

from typing import List, Optional
from pydantic import BaseModel, ValidationError, field_validator
from avis_client.models.patched_binary_class_inspection_result_typed_request import (
    PatchedBinaryClassInspectionResultTypedRequest,
)
from avis_client.models.patched_rating_inspection_result_typed_request import (
    PatchedRatingInspectionResultTypedRequest,
)
from typing import Union, Dict
from typing_extensions import Literal

try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

PATCHEDINSPECTIONRESULTPOLYMORPHICREQUEST_ONE_OF_SCHEMAS = [
    "PatchedBinaryClassInspectionResultTypedRequest",
    "PatchedRatingInspectionResultTypedRequest",
]


class PatchedInspectionResultPolymorphicRequest(BaseModel):
    """
    PatchedInspectionResultPolymorphicRequest
    """

    # data type: PatchedRatingInspectionResultTypedRequest
    oneof_schema_1_validator: Optional[PatchedRatingInspectionResultTypedRequest] = None
    # data type: PatchedBinaryClassInspectionResultTypedRequest
    oneof_schema_2_validator: Optional[
        PatchedBinaryClassInspectionResultTypedRequest
    ] = None
    actual_instance: Optional[
        Union[
            PatchedBinaryClassInspectionResultTypedRequest,
            PatchedRatingInspectionResultTypedRequest,
        ]
    ] = None
    one_of_schemas: List[str] = Literal[
        "PatchedBinaryClassInspectionResultTypedRequest",
        "PatchedRatingInspectionResultTypedRequest",
    ]

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError(
                    "If a position argument is used, only 1 is allowed to set `actual_instance`"
                )
            if kwargs:
                raise ValueError(
                    "If a position argument is used, keyword arguments cannot be used."
                )
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = PatchedInspectionResultPolymorphicRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: PatchedRatingInspectionResultTypedRequest
        if not isinstance(v, PatchedRatingInspectionResultTypedRequest):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `PatchedRatingInspectionResultTypedRequest`"
            )
        else:
            match += 1
        # validate data type: PatchedBinaryClassInspectionResultTypedRequest
        if not isinstance(v, PatchedBinaryClassInspectionResultTypedRequest):
            error_messages.append(
                f"Error! Input type `{type(v)}` is not `PatchedBinaryClassInspectionResultTypedRequest`"
            )
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in PatchedInspectionResultPolymorphicRequest with oneOf schemas: PatchedBinaryClassInspectionResultTypedRequest, PatchedRatingInspectionResultTypedRequest. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in PatchedInspectionResultPolymorphicRequest with oneOf schemas: PatchedBinaryClassInspectionResultTypedRequest, PatchedRatingInspectionResultTypedRequest. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into PatchedRatingInspectionResultTypedRequest
        try:
            instance.actual_instance = (
                PatchedRatingInspectionResultTypedRequest.from_json(json_str)
            )
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PatchedBinaryClassInspectionResultTypedRequest
        try:
            instance.actual_instance = (
                PatchedBinaryClassInspectionResultTypedRequest.from_json(json_str)
            )
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into PatchedInspectionResultPolymorphicRequest with oneOf schemas: PatchedBinaryClassInspectionResultTypedRequest, PatchedRatingInspectionResultTypedRequest. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into PatchedInspectionResultPolymorphicRequest with oneOf schemas: PatchedBinaryClassInspectionResultTypedRequest, PatchedRatingInspectionResultTypedRequest. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
